#ifndef  MODULES_WINMGR_H
#define  MODULES_WINMGR_H

/*
**   winmgr.h
**
**   (C) Copyright 2001-2002 Rocklyte Systems.
**       All Rights Reserved.
*/

#ifndef  MAIN_H
#include <pandora/main.h>
#endif

#define WNS_PLUGIN 0x00000001

#define MODVERSION_WINMGR ((FLOAT)1.0)

#ifndef LOCAL_WINMGR

struct WinBase {
   LONG (*GetDisplaySettings)(LONG *, LONG *, LONG *);
   APTR (*CreateScreen)(LONG *, LONG *, LONG *, LONG *, LONG, STRING);
   LONG (*ShowWindow)(APTR, LONG);
   void (*UpdateWindow)(APTR);
   LONG (*GetModuleHandle)(void);
   void (*SetRenderID)(APTR, OBJECTID);
   APTR (*GetDC)(APTR);
   void (*ReleaseDC)(APTR, APTR);
   LONG (*DestroyWindow)(APTR);
   LONG (*ReadKey)(STRING, STRING, STRING, LONG);
   void (*FindClose)(APTR);
   LONG (*GetDesktopSize)(LONG *, LONG *);
   APTR (*FindWindow)(STRING, STRING);
   LONG (*GetWindowInfo)(APTR, LONG *, LONG *, LONG *, LONG *, LONG *);
   LONG (*ResizeWindow)(APTR, LONG, LONG);
   LONG (*MoveWindow)(APTR, LONG, LONG);
   APTR (*SetWindowProcedure)(WINHANDLE, APTR);
   LONG (*Settings)(LONG);
   APTR (*CreateChild)(APTR, LONG, LONG, LONG, LONG);
   void (*SetWindowTitle)(APTR, STRING);
   LONG (*HideWindow)(APTR);
};

#define winCreateChild(a,b,c,d,e)      (WinBase->CreateChild(a,b,c,d,e))
#define winCreateScreen(a,b,c,d,e,f)   (WinBase->CreateScreen(a,b,c,d,e,f))
#define winDestroyWindow(a)            (WinBase->DestroyWindow(a))
#define winFindClose(a)                (WinBase->FindClose(a))
#define winFindWindow(a,b)             (WinBase->FindWindow(a,b))
#define winGetDC(a)                    (WinBase->GetDC(a))
#define winGetDesktopSize(a,b)         (WinBase->GetDesktopSize(a,b))
#define winGetDisplaySettings(a,b,c)   (WinBase->GetDisplaySettings(a,b,c))
#define winGetModuleHandle()           (WinBase->GetModuleHandle())
#define winGetWindowInfo(a,b,c,d,e,f)  (WinBase->GetWindowInfo(a,b,c,d,e,f))
#define winHideWindow(a)               (WinBase->HideWindow(a))
#define winSetWindowProcedure(a,b)     (WinBase->SetWindowProcedure(a,b))
#define winMoveWindow(a,b,c)           (WinBase->MoveWindow(a,b,c))
#define winReadKey(a,b,c,d)            (WinBase->ReadKey(a,b,c,d))
#define winReleaseDC(a,b)              (WinBase->ReleaseDC(a,b))
#define winResizeWindow(a,b,c)         (WinBase->ResizeWindow(a,b,c))
#define winSettings(a)                 (WinBase->Settings(a))
#define winShowWindow(a,b)             (WinBase->ShowWindow(a,b))
#define winSetRenderID(a,b)            (WinBase->SetRenderID(a,b))
#define winSetWindowTitle(a,b)         (WinBase->SetWindowTitle(a,b))
#define winUpdateWindow(a)             (WinBase->UpdateWindow(a))

#else

APTR winCreateChild(LONG, LONG, LONG, LONG, LONG);
APTR winCreateScreen(LONG *, LONG *, LONG *, LONG *, LONG, STRING);
LONG winDestroyWindow(APTR);
ERROR winDetermineWindow(LONG, LONG, LONG *, LONG *, OBJECTID *);
void winFindClose(APTR);
APTR winFindWindow(STRING, STRING);
APTR winGetDC(APTR);
LONG winGetDesktopSize(LONG *, LONG *);
LONG winGetDisplaySettings(LONG *, LONG *, LONG *);
LONG winGetModuleHandle(void);
LONG winGetWindowInfo(APTR, LONG *, LONG *, LONG *, LONG *, LONG *);
LONG winHideWindow(APTR);
LONG winMoveWindow(APTR, LONG, LONG);
LONG winReadKey(STRING, STRING, STRING, LONG);
void winReleaseDC(APTR, APTR);
LONG winResizeWindow(APTR, LONG, LONG);
void winSetRenderID(APTR, OBJECTID);
LONG winSettings(LONG);
APTR winSetWindowProcedure(WINHANDLE, APTR);
void winSetWindowTitle(WINHANDLE, STRING);
LONG winShowWindow(APTR, LONG);
void winUpdateWindow(APTR);

#endif /* LOCAL_WINMGR */

#endif /* MODULES_WINMGR_H */
